package com.persagy.revit.services

import com.persagy.mybatis.SMybatisDao
import com.persagy.revit.models.entities.*
import com.persagy.revit.models.log.SyncLogEntity
import com.persagy.revit.models.modelFile.FloorModel
import com.persagy.revit.models.modelFile.ModelFile
import com.persagy.revit.models.modelFile.ModelFileFolder
import com.persagy.revit.models.monitor.ModelMonitor
import com.persagy.service.SObjectService

/**
 *
 *
 * @author jxing
 */
object BaseDataService {
    val modelFileService = SObjectService(SMybatisDao(ModelFile::class.java))
    val modelMonitorService = SObjectService(SMybatisDao(ModelMonitor::class.java))
    val columnService = SObjectService(SMybatisDao(Column::class.java))
    val doorService = SObjectService(SMybatisDao(Door::class.java))
    val spaceService = SObjectService(SMybatisDao(Space::class.java))
    val virtualWallService = SObjectService(SMybatisDao(VirtualWall::class.java))
    val wallService = SObjectService(SMybatisDao(Wall::class.java))
    val windowService = SObjectService(SMybatisDao(Window::class.java))
    val beaconService = SObjectService(SMybatisDao(Beacon::class.java))
    val floorModelService = SObjectService(SMybatisDao(FloorModel::class.java))
    var boundarySegmentService = SObjectService(SMybatisDao(BoundarySegment::class.java))
    val folderService = SObjectService(SMybatisDao(ModelFileFolder::class.java))     // 连接线断
    val connectorService = SObjectService(SMybatisDao(Connector::class.java))   // 连接件
    val otherService = SObjectService(SMybatisDao(Other::class.java))      // 其他对象
    val joinObjectService = SObjectService(SMybatisDao(JoinObject::class.java))      // 其他对象
    val gridService = SObjectService(SMybatisDao(Grid::class.java))  // 轴网
    val levelService = SObjectService(SMybatisDao(Level::class.java))  // 标高
    val pipeService = SObjectService(SMybatisDao(Pipe::class.java))  // 标高
    val ductService = SObjectService(SMybatisDao(Duct::class.java))  // 标高
    val equipmentService = SObjectService(SMybatisDao(Equipment::class.java))  // 标高
    val componentService = SObjectService(SMybatisDao(EquipPart::class.java))  // 标高
    val syncLogService = SObjectService(SMybatisDao(SyncLogEntity::class.java))  // 标高
}